/* $Id: lights.cc,v 1.3 1995/08/03 18:45:43 sean Exp sean $ */
/*
$Log: lights.cc,v $
Revision 1.3  1995/08/03 18:45:43  sean
simple list of lights.

*/
#include <stdio.h>
#include "lights.h"

LightSource::LightSource(lightSourceTag tag, v3 where, real brightness,
			 v3 spec)
{
  sourceTag = tag;
  spectrum = new v3;
  *spectrum = spec;
  intensity = brightness;
  switch (tag) {
  case pointTag: 
    point = new v3;
    *point = where;
    break;
  case directionTag:
    direction = new v3;
    *direction = where;
    break;
  default:
    break;
  } //switch
}

v3 * LightSource::Normal(v3 *intersection)
{
  v3 *result;

  result = new v3;
  switch (sourceTag) {
  case pointTag:
    *result = *point - *intersection;
    break;
  case directionTag:
    *result = *direction;
    break;
  default:
    break;
  } //switch
  return result;
}

void LightSource::Print() 
{
  switch (sourceTag) {
  case pointTag: 
    printf("Point source at ");
    point->print();
    printf(" with intensity %2.3f and spectrum ",intensity);
    spectrum->print();
    printf("\n");
    break;
  case directionTag: 
    printf("Directional source ");
    direction->print();
    printf(" with intensity %2.3f and spectrum ", intensity);
    spectrum->print();
    printf("\n");
    break;
  default:
    break;
  } // switch sourceTag
}

LightList::LightList(LightList *listroot)
{
  if (listroot == NULL)
    root = current = NULL;
  else
    root = current = listroot->root;
}

// Add a light source to the head of the light source list.
void  LightList::Add(LightSource *source) {
  LightNode *new_node;
  new_node = new LightNode;
  new_node->light = source;
  new_node->next = root;
  root = new_node;
}

// reset current pointer to first lightsource in list
// return first source
LightSource * LightList::First() {
  current = root;
  return current->light;
}

// return next lightsource based on current
LightSource * LightList::Next() {
  if (current == NULL)
    return NULL;
  current = current->next;
  if (current == NULL)
    return NULL;
  return current->light;
}

void LightList::Print() {
  LightSource *lightsource;

  lightsource = First();
  while (lightsource != NULL) {
    lightsource->Print();
    lightsource = Next();
  }
}



