/* $Id: matrix.h,v 1.6 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: matrix.h,v $
Revision 1.6  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.5  1995/08/03 18:45:43  sean
dirt matrix library

*/
#ifndef MATRIX_H
#define MATRIX_H
#define real float
// might want to change this to double.

#define i2PI 0.15915494 
#define iPI 0.31830989
class v1 {
public:
  real x;
  v1(real val) {x = val;}
  v1(void) {x = 0.0;}
  friend v1 operator+(v1,v1);
  friend v1 operator-(v1,v1);
  friend v1 operator-(v1);
  friend v1 operator*(v1, v1);
  friend v1 operator/(v1, v1);
  void print();
};

class v2 {
public:
  real x,y;
  v2(real valx, real valy) {x = valx; y = valy;};
  v2(void) {x = 0.0; y = 0.0;};
  friend v2 operator+(v2,v2);
  friend v2 operator-(v2,v2);
  friend v2 operator-(v2);
  friend v2 operator*(v2, v2);
  real length();
  v2 unit();
  void print();
};

v2 v2_scalar_mul(real, v2);
v2 v2_dot(v2, v2);

class v3 {
public:
  real x,y,z;
  v3(real valx, real valy, real valz) {x = valx; y = valy; z = valz;};
  v3() {x = 0.0; y = 0.0; z = 0.0;};
  friend v3 operator+(v3,v3);
  friend v3 operator-(v3,v3);
  friend v3 operator-(v3);
  friend v3 operator*(v3, v3);
  real length();
  v3 unit();
  v3 positive();
  void print();
};

v3 v3_scalar_mul(real, v3);
v3 v3_cross(v3, v3);
real v3_dot(v3, v3);
  
class m2 {
public:
  real e11, e12, 
       e21, e22;
  m2(real t11, real t12, real t21, real t22) 
    { e11 = t11; e12 = t12; e21 = t21; e22 = t22; };
  m2(void) { e11 = 0.0; e12 = 0.0; e21 = 0.0; e22 = 0.0; };
//  friend m2 operator+(m2,m2);
//  friend m2 operator-(m2,m2);
  friend m2 operator-(m2);
  friend m2 operator*(m2, m2);
  friend v2 operator*(m2, v2);
  m2 inv();
  real det();
  void print();
};

m2 m2_scalar_mul(real, m2);

class m3 {
public:
  real e11, e12, e13,
       e21, e22, e23,
       e31, e32, e33; 
  m3(real t11, real t12, real t13, real t21, real t22, real t23, 
     real t31, real t32, real t33) 
    { e11 = t11; e12 = t12; e13 = t13;
      e21 = t21; e22 = t22; e23 = t23;
      e31 = t31; e32 = t32; e33 = t33;
    };
  m3()
    { e11 = 0.0; e12 = 0.0; e13 = 0.0;
      e21 = 0.0; e22 = 0.0; e23 = 0.0;
      e31 = 0.0; e32 = 0.0; e33 = 0.0;
    };
//  friend m3 operator+(m3,m3);
//  friend m3 operator-(m3,m3);
  friend m3 operator-(m3);
  friend m3 operator*(m3, m3);
  friend v3 operator*(m3, v3);
  void print();
};

m3 m3_scalar_mul(real, m3);

class m4 {
 public:
  real e11, e12, e13, e14, 
  e21, e22, e23, e24, 
  e31, e32, e33, e34,
  e41, e42, e43, e44;
  m4(real t11, real t12, real t13, real t14, 
     real t21, real t22, real t23, real t24, 
     real t31, real t32, real t33, real t34, 
     real t41, real t42, real t43, real t44)
    { e11 = t11; e12 = t12; e13 = t13; e14 = t14;
      e21 = t21; e22 = t22; e23 = t23; e24 = t24;
      e31 = t31; e32 = t32; e33 = t33; e34 = t34;
      e41 = t41; e42 = t42; e43 = t43; e44 = t44;
    };
  m4(void)
    { e11 = 0.0; e12 = 0.0; e13 = 0.0; e14 = 0.0;
      e21 = 0.0; e22 = 0.0; e23 = 0.0; e24 = 0.0;
      e31 = 0.0; e32 = 0.0; e33 = 0.0; e34 = 0.0;
      e41 = 0.0; e42 = 0.0; e43 = 0.0; e44 = 0.0;
    };
//  friend m4 operator+(m4,m4);
//  friend m4 operator-(m4,m4);
  friend m4 operator-(m4);
  friend m4 operator*(m4, m4);
  void print();
};

m4 m4_scalar_mul(real, m4);

#endif
