/* $Id: ppmutil.cc,v 1.4 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: ppmutil.cc,v $
Revision 1.4  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.3  1995/08/03 18:45:43  sean
So far, only color binary pixmaps are supported, P6
Should add gray pixmaps for bump mapping.

*/
#include <stdio.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "ppmutil.h"



PPMrast::PPMrast(char *fname)
{
	FILE *ppmfile;
	int result;

	counter = 0;
	if ((ppmfile = fopen(fname, "r")) == NULL)
	{
		fprintf(stderr, "PPM file %s could not be opened for reading\n",
			fname);
		exit(0);
	}
	filename = strdup(fname);
	result = readppm(ppmfile);

}

v3 PPMrast::getpixel(v2 point)
{
	v3 result;
	int cx, cy;

	cx = (int) (point.x * width);
	cy = (int) (point.y * height);

	if ((cx > width) || (cx < - 0.1) || (cy > height) || (cy < - 0.1))
	{
		printf("Problem! %f %f \n", cx, cy);
		return v3(0.0, 0.0, 0.0);
	}
	if (r == NULL)
		printf("Damn! %d %s\n", counter, filename);
	counter++;
	result.x = (real) ((unsigned char) r[width * cy + cx]) / (real) maxval;
	if (ppmtype == '6') {
		result.y = (real) ((unsigned char) g[width * cy + cx]) / (real) maxval;
		result.z = (real) ((unsigned char) b[width * cy + cx]) / (real) maxval;
	} else {
		result.y = result.z = result.x;
	}
	if (result.x < 0.0) 
		result.x = 0.0;
	if (result.y < 0.0) 
		result.y = 0.0;
	if (result.z < 0.0)
		result.z = 0.0;
	return result;
}

int PPMrast::readppm(FILE *ppmfile)
{
	int c;
	int numpixels, i;
	
	

	c = fgetc(ppmfile);
	if (c != 'P')
		ppmerror("Wrong Magic Number", filename);
	ppmtype = fgetc(ppmfile);
        if ((ppmtype != '6') && (ppmtype != '5'))
                ppmerror("Wrong Magic Number ", filename);
	while ((c = fgetc(ppmfile)) != EOF)
	{
		if (c == '#')
			ppmcomment(filename, ppmfile);
		else if (isdigit(c)) 
		{
			width = ppmnum(filename, ppmfile, c);		
			break;	
		}
	}
	while ((c = fgetc(ppmfile)) != EOF)
        {
                if (c == '#')
                        ppmcomment(filename, ppmfile);
                else if (isdigit(c))
		{
                        height = ppmnum(filename, ppmfile, c);   
			break;
		}
        }
	while ((c = fgetc(ppmfile)) != EOF)
        {
                if (c == '#')
                        ppmcomment(filename, ppmfile);
                else if (isdigit(c))
		{
                        maxval = ppmnum(filename, ppmfile, c);   
			break;
		}
        }
	printf("ppmfile %s has width %d, height %d, and maxval %d \n",
		filename, width, height, maxval);
	if ((height < 1) || (width < 1))
		ppmerror("heidht and width out of range", filename);
	inv_width = 1.0 / (real) width;
	inv_height = 1.0 / (real) height;
	numpixels = width * height;
	if ((r = (char *) malloc(sizeof(char) * numpixels)) == 0)
		ppmerror("Couldn't malloc for r", filename);
        if (ppmtype == '6') {
		if ((g = (char *) malloc(sizeof(char) * numpixels)) == 0)
			ppmerror("Couldn't malloc for g", filename);
		if ((b = (char *) malloc(sizeof(char) * numpixels)) == 0)
			ppmerror("Couldn't malloc for b", filename);
	}
	//c = fgetc(ppmfile);
	//c = fgetc(ppmfile);
	if (ppmtype == '6')
	{
		for (i = 0; i < numpixels; i++)
		{
		  	r[i] = fgetc(ppmfile);
		  	g[i] = fgetc(ppmfile);
		  	b[i] = fgetc(ppmfile);
	 	}
	}
	else
	{
		for (i = 0; i < numpixels; i++)
			r[i] = fgetc(ppmfile);
	}
}

void ppmcomment(char *fname, FILE *ppmfile)
{
	char c;
	
	while ((fread(&c, sizeof(char), 1, ppmfile)) == 1)
		if (c == '\n')
			return;
}

void ppmerror(char *complaint, char *filename)
{
	fprintf(stderr, "ERROR: PPM file [%s]: %s\n", filename, complaint);
//	exit(0);
}

int ppmnum(char *fname, FILE *ppmfile, char firstdigit)
{
	int result;
	unsigned char c;
	
	result = firstdigit - '0';
	c = fgetc(ppmfile);
	while (isdigit(c)) 
	{
		result = result * 10 + c - '0';
		c = fgetc(ppmfile);
	}
	return result;
}
