/* $Id: surfprops.cc,v 1.3 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: surfprops.cc,v $
Revision 1.3  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.2  1995/08/03 18:45:43  sean
Can do color and pixmapping.  Need to add bump mapping and add procedural
coloring and bumping (like mandlebrot set color map)

*/
#include "surfprops.h"

SurfProps::SurfProps( real newdiff, real newspec, real newtransp, real newrefl,
		propcolorTag coltag, void *defcolor, 
		propbumpTag bmptag, void *defbump)
{
	colortag = coltag;
	bumptag = bmptag;
	switch (colortag) {
		case Constant_color:	color = (v3 *) defcolor;
					break;
		case Pixmap_color:	ppmcolor = (PPMrast *) defcolor;
					break;
		default:		break;
	};
	switch (bumptag) {
		case Constant_bump: 	break;
		case Pixmap_bump:	ppmbump = (PPMrast *) defbump;
					break;
		default:		break;
	};
	diffuse = newdiff;
	specular = newspec;
	transp = newtransp;
	refl = newrefl;
}



v3 SurfProps::Color( v2 hitpoint)
{
	v3 result;

	switch (colortag) {
       		case Constant_color:    result = *color;
               				break;
        	case Pixmap_color:      if (hitpoint.x < 0.0)
				                hitpoint.x *= -1.0;
				        if (hitpoint.y < 0.0)
				                hitpoint.y *= -1.0;
				        if (hitpoint.x > 1.0)
				                hitpoint.x -= (int) hitpoint.x;
				        if (hitpoint.y > 1.0)
				                hitpoint.y -= (int) hitpoint.y;
					result = ppmcolor->getpixel(hitpoint);
               		                break;
    	    	default:                break;
        };
	return result;
}

real SurfProps::Bump( v2 hitpoint)
{
	real result;

        if (hitpoint.x < 0.0)
                hitpoint.x *= -1.0;
        if (hitpoint.y < 0.0)
                hitpoint.y *= -1.0;
        if (hitpoint.x > 1.0)
                hitpoint.x -= (int) hitpoint.x;
        if (hitpoint.y > 1.0)
                hitpoint.y -= (int) hitpoint.y;
	result = ppmbump->getpixel(hitpoint).x;
	return result;
}

