/* $Id: surfprops.h,v 1.3 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: surfprops.h,v $
Revision 1.3  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.2  1995/08/03 18:45:43  sean
Surface Properties, incl. diffuse const, refl const, spec const, trans const
color / colormap

*/
#ifndef SURFPROPS_H
#define SURFPROPS_H

#include "matrix.h"
#include "ray.h"
#include "ppmutil.h"


typedef enum {Constant_color, Pixmap_color} propcolorTag;
typedef enum {Constant_bump, Pixmap_bump} propbumpTag;
class SurfProps {
  public:
	propcolorTag colortag;
	propbumpTag bumptag;
	union {
		v3 *color;
		PPMrast *ppmcolor;
	       };
        PPMrast *ppmbump;
	real diffuse, specular, transp, refl;
	SurfProps(real newdiff, real newspec, real newtransp, real newrefl,
		propcolorTag, void *, propbumpTag, void *);
	v3 Color( v2 hit_point);
	real Bump( v2 hit_point);
};

	
#endif
